diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/cursor.c vnc_unixsrc/vncviewer/cursor.c
--- vnc_unixsrc.orig/vncviewer/cursor.c	2003-01-15 04:46:52.000000000 -0500
+++ vnc_unixsrc/vncviewer/cursor.c	2010-02-25 22:04:28.000000000 -0500
@@ -38,8 +38,11 @@
 
 
 static Bool prevSoftCursorSet = False;
-static Pixmap rcSavedArea;
-static CARD8 *rcSource, *rcMask;
+static Pixmap rcSavedArea, rcSavedArea_0;
+static int rcSavedArea_w = -1, rcSavedArea_h = -1;
+static char *rcSavedScale = NULL;
+static int rcSavedScale_len = 0;
+static CARD8 *rcSource = NULL, *rcMask;
 static int rcHotX, rcHotY, rcWidth, rcHeight;
 static int rcCursorX = 0, rcCursorY = 0;
 static int rcLockX, rcLockY, rcLockWidth, rcLockHeight;
@@ -48,8 +51,13 @@
 static Bool SoftCursorInLockedArea(void);
 static void SoftCursorCopyArea(int oper);
 static void SoftCursorDraw(void);
-static void FreeSoftCursor(void);
-static void FreeX11Cursor();
+void FreeSoftCursor(void);
+void FreeX11Cursor();
+
+extern XImage *image;
+extern XImage *image_scale;
+extern int scale_x, scale_y;
+int scale_round(int n, double factor);
 
 /* Copied from Xvnc/lib/font/util/utilbitmap.c */
 static unsigned char _reverse_byte[0x100] = {
@@ -91,6 +99,8 @@
 static Bool prevXCursorSet = False;
 static Cursor prevXCursor;
 
+extern double scale_factor_x;
+extern double scale_factor_y;
 
 Bool HandleXCursor(int xhot, int yhot, int width, int height)
 {
@@ -124,7 +134,7 @@
     XQueryBestCursor(dpy, dr, width, height, &wret, &hret);
   }
 
-  if (width * height == 0 || wret < width || hret < height) {
+  if (width * height == 0 || (int) wret < width || (int) hret < height) {
     /* Free resources */
     if (buf != NULL)
       free(buf);
@@ -139,7 +149,7 @@
   fg.green = (unsigned short)colors.foreGreen << 8 | colors.foreGreen;
   fg.blue  = (unsigned short)colors.foreBlue  << 8 | colors.foreBlue;
 
-  for (i = 0; i < bytesData * 2; i++)
+  for (i = 0; (size_t) i < bytesData * 2; i++)
     buf[i] = (char)_reverse_byte[(int)buf[i] & 0xFF];
 
   source = XCreateBitmapFromData(dpy, dr, buf, width, height);
@@ -167,148 +177,179 @@
 
 Bool HandleCursorShape(int xhot, int yhot, int width, int height, CARD32 enc)
 {
-  int bytesPerPixel;
-  size_t bytesPerRow, bytesMaskData;
-  Drawable dr;
-  rfbXCursorColors rgb;
-  CARD32 colors[2];
-  char *buf;
-  CARD8 *ptr;
-  int x, y, b;
-
-  bytesPerPixel = myFormat.bitsPerPixel / 8;
-  bytesPerRow = (width + 7) / 8;
-  bytesMaskData = bytesPerRow * height;
-  dr = DefaultRootWindow(dpy);
-
-  FreeSoftCursor();
+	int bytesPerPixel;
+	size_t bytesPerRow, bytesMaskData;
+	Drawable dr;
+	rfbXCursorColors rgb;
+	CARD32 colors[2];
+	char *buf;
+	CARD8 *ptr;
+	int x, y, b;
+
+	bytesPerPixel = myFormat.bitsPerPixel / 8;
+	bytesPerRow = (width + 7) / 8;
+	bytesMaskData = bytesPerRow * height;
+	dr = DefaultRootWindow(dpy);
 
-  if (width * height == 0)
-    return True;
-
-  /* Allocate memory for pixel data and temporary mask data. */
+	FreeSoftCursor();
 
-  rcSource = malloc(width * height * bytesPerPixel);
-  if (rcSource == NULL)
-    return False;
-
-  buf = malloc(bytesMaskData);
-  if (buf == NULL) {
-    free(rcSource);
-    return False;
-  }
+	if (width * height == 0) {
+		return True;
+	}
 
-  /* Read and decode cursor pixel data, depending on the encoding type. */
+	/* Allocate memory for pixel data and temporary mask data. */
 
-  if (enc == rfbEncodingXCursor) {
-    if (appData.useX11Cursor) {
-      HandleXCursor(xhot, yhot, width, height);
-      return True;
-    }
+	rcSource = malloc(width * height * bytesPerPixel);
+	if (rcSource == NULL) {
+		return False;
+	}
 
-    /* Read and convert background and foreground colors. */
-    if (!ReadFromRFBServer((char *)&rgb, sz_rfbXCursorColors)) {
-      free(rcSource);
-      free(buf);
-      return False;
-    }
-    colors[0] = RGB24_TO_PIXEL(32, rgb.backRed, rgb.backGreen, rgb.backBlue);
-    colors[1] = RGB24_TO_PIXEL(32, rgb.foreRed, rgb.foreGreen, rgb.foreBlue);
+	buf = malloc(bytesMaskData);
+	if (buf == NULL) {
+		free(rcSource);
+		rcSource = NULL;
+		return False;
+	}
 
-    /* Read 1bpp pixel data into a temporary buffer. */
-    if (!ReadFromRFBServer(buf, bytesMaskData)) {
-      free(rcSource);
-      free(buf);
-      return False;
-    }
+	/* Read and decode cursor pixel data, depending on the encoding type. */
 
-    /* Convert 1bpp data to byte-wide color indices. */
-    ptr = rcSource;
-    for (y = 0; y < height; y++) {
-      for (x = 0; x < width / 8; x++) {
-	for (b = 7; b >= 0; b--) {
-	  *ptr = buf[y * bytesPerRow + x] >> b & 1;
-	  ptr += bytesPerPixel;
-	}
-      }
-      for (b = 7; b > 7 - width % 8; b--) {
-	*ptr = buf[y * bytesPerRow + x] >> b & 1;
-	ptr += bytesPerPixel;
-      }
-    }
+	if (enc == rfbEncodingXCursor) {
+		if (appData.useX11Cursor) {
+			HandleXCursor(xhot, yhot, width, height);
+			return True;
+		}
+
+		/* Read and convert background and foreground colors. */
+		if (!ReadFromRFBServer((char *)&rgb, sz_rfbXCursorColors)) {
+			free(rcSource);
+			rcSource = NULL;
+			free(buf);
+			return False;
+		}
+		colors[0] = RGB24_TO_PIXEL(32, rgb.backRed, rgb.backGreen, rgb.backBlue);
+		colors[1] = RGB24_TO_PIXEL(32, rgb.foreRed, rgb.foreGreen, rgb.foreBlue);
+
+		/* Read 1bpp pixel data into a temporary buffer. */
+		if (!ReadFromRFBServer(buf, bytesMaskData)) {
+			free(rcSource);
+			rcSource = NULL;
+			free(buf);
+			return False;
+		}
+
+		/* Convert 1bpp data to byte-wide color indices. */
+		ptr = rcSource;
+		for (y = 0; y < height; y++) {
+			for (x = 0; x < width / 8; x++) {
+				for (b = 7; b >= 0; b--) {
+					*ptr = buf[y * bytesPerRow + x] >> b & 1;
+					ptr += bytesPerPixel;
+				}
+			}
+			for (b = 7; b > 7 - width % 8; b--) {
+				*ptr = buf[y * bytesPerRow + x] >> b & 1;
+				ptr += bytesPerPixel;
+			}
+		}
+
+		/* Convert indices into the actual pixel values. */
+		switch (bytesPerPixel) {
+		case 1:
+			for (x = 0; x < width * height; x++) {
+				rcSource[x] = (CARD8)colors[rcSource[x]];
+			}
+			break;
+		case 2:
+			for (x = 0; x < width * height; x++) {
+				((CARD16 *)rcSource)[x] = (CARD16)colors[rcSource[x * 2]];
+			}
+			break;
+		case 4:
+			for (x = 0; x < width * height; x++) {
+				((CARD32 *)rcSource)[x] = colors[rcSource[x * 4]];
+			}
+			break;
+		}
+
+	} else {	/* enc == rfbEncodingRichCursor */
+		if (!ReadFromRFBServer((char *)rcSource, width * height * bytesPerPixel)) {
+			free(rcSource);
+			rcSource = NULL;
+			free(buf);
+			return False;
+		}
+	}
 
-    /* Convert indices into the actual pixel values. */
-    switch (bytesPerPixel) {
-    case 1:
-      for (x = 0; x < width * height; x++)
-	rcSource[x] = (CARD8)colors[rcSource[x]];
-      break;
-    case 2:
-      for (x = 0; x < width * height; x++)
-	((CARD16 *)rcSource)[x] = (CARD16)colors[rcSource[x * 2]];
-      break;
-    case 4:
-      for (x = 0; x < width * height; x++)
-	((CARD32 *)rcSource)[x] = colors[rcSource[x * 4]];
-      break;
-    }
+	/* Read and decode mask data. */
 
-  } else {			/* enc == rfbEncodingRichCursor */
+	if (!ReadFromRFBServer(buf, bytesMaskData)) {
+		free(rcSource);
+		rcSource = NULL;
+		free(buf);
+		return False;
+	}
 
-    if (!ReadFromRFBServer((char *)rcSource, width * height * bytesPerPixel)) {
-      free(rcSource);
-      free(buf);
-      return False;
-    }
+	rcMask = malloc(width * height);
+	if (rcMask == NULL) {
+		free(rcSource);
+		rcSource = NULL;
+		free(buf);
+		return False;
+	}
 
-  }
+	ptr = rcMask;
+	for (y = 0; y < height; y++) {
+		for (x = 0; x < width / 8; x++) {
+			for (b = 7; b >= 0; b--) {
+				*ptr++ = buf[y * bytesPerRow + x] >> b & 1;
+			}
+		}
+		for (b = 7; b > 7 - width % 8; b--) {
+			*ptr++ = buf[y * bytesPerRow + x] >> b & 1;
+		}
+	}
 
-  /* Read and decode mask data. */
+	free(buf);
 
-  if (!ReadFromRFBServer(buf, bytesMaskData)) {
-    free(rcSource);
-    free(buf);
-    return False;
-  }
+	/* Set remaining data associated with cursor. */
 
-  rcMask = malloc(width * height);
-  if (rcMask == NULL) {
-    free(rcSource);
-    free(buf);
-    return False;
-  }
+	dr = DefaultRootWindow(dpy);
 
-  ptr = rcMask;
-  for (y = 0; y < height; y++) {
-    for (x = 0; x < width / 8; x++) {
-      for (b = 7; b >= 0; b--) {
-	*ptr++ = buf[y * bytesPerRow + x] >> b & 1;
-      }
-    }
-    for (b = 7; b > 7 - width % 8; b--) {
-      *ptr++ = buf[y * bytesPerRow + x] >> b & 1;
-    }
-  }
+	if (scale_x > 0) {
+		int w = scale_round(width,  scale_factor_x) + 2;
+		int h = scale_round(height, scale_factor_y) + 2;
+		rcSavedArea = XCreatePixmap(dpy, dr, w, h, visdepth);
+		rcSavedArea_w = w;
+		rcSavedArea_h = h;
+	} else {
+		rcSavedArea = XCreatePixmap(dpy, dr, width, height, visdepth);
+		rcSavedArea_w = width;
+		rcSavedArea_h = height;
+	}
+	rcSavedArea_0 = XCreatePixmap(dpy, dr, width, height, visdepth);
 
-  free(buf);
+if (0) fprintf(stderr, "rcSavedArea_wh: %d %d scale_x: %d\n", rcSavedArea_w, rcSavedArea_h, scale_x); 
 
-  /* Set remaining data associated with cursor. */
+	if (rcSavedScale_len < 4 * width * height + 4096)  {
+		if (rcSavedScale) {
+			free(rcSavedScale);
+		}
+		rcSavedScale = (char *) malloc(2 * 4 * width * height + 4096);
+	}
 
-  dr = DefaultRootWindow(dpy);
-  rcSavedArea = XCreatePixmap(dpy, dr, width, height, visdepth);
-  rcHotX = xhot;
-  rcHotY = yhot;
-  rcWidth = width;
-  rcHeight = height;
+	rcHotX = xhot;
+	rcHotY = yhot;
+	rcWidth = width;
+	rcHeight = height;
 
-  SoftCursorCopyArea(OPER_SAVE);
-  SoftCursorDraw();
+	SoftCursorCopyArea(OPER_SAVE);
+	SoftCursorDraw();
 
-  rcCursorHidden = False;
-  rcLockSet = False;
+	rcCursorHidden = False;
+	rcLockSet = False;
 
-  prevSoftCursorSet = True;
-  return True;
+	prevSoftCursorSet = True;
+	return True;
 }
 
 /*********************************************************************
@@ -319,20 +360,27 @@
 
 Bool HandleCursorPos(int x, int y)
 {
-  if (appData.useX11Cursor) {
-    if (appData.fullScreen)
-      XWarpPointer(dpy, None, desktopWin, 0, 0, 0, 0, x, y);
-    
-    return True; 
-  }
+	if (x < 0) x = 0;
+	if (y < 0) y = 0;
 
-  if (x >= si.framebufferWidth)
-    x = si.framebufferWidth - 1;
-  if (y >= si.framebufferHeight)
-    y = si.framebufferHeight - 1;
+	/* fprintf(stderr, "xy: %d %d\n", x, y); */
 
-  SoftCursorMove(x, y);
-  return True;
+	if (x >= si.framebufferWidth) {
+		x = si.framebufferWidth - 1;
+	}
+	if (y >= si.framebufferHeight) {
+		y = si.framebufferHeight - 1;
+	}
+
+	if (appData.useX11Cursor) {
+		if (appData.fullScreen) {
+			XWarpPointer(dpy, None, desktopWin, 0, 0, 0, 0, x, y);
+		}
+		return True; 
+	}
+
+	SoftCursorMove(x, y);
+	return True;
 }
 
 /*********************************************************************
@@ -348,30 +396,31 @@
 {
   int newX, newY;
 
-  if (!prevSoftCursorSet)
-    return;
+	if (!prevSoftCursorSet) {
+		return;
+	}
 
-  if (!rcLockSet) {
-    rcLockX = x;
-    rcLockY = y;
-    rcLockWidth = w;
-    rcLockHeight = h;
-    rcLockSet = True;
-  } else {
-    newX = (x < rcLockX) ? x : rcLockX;
-    newY = (y < rcLockY) ? y : rcLockY;
-    rcLockWidth = (x + w > rcLockX + rcLockWidth) ?
-      (x + w - newX) : (rcLockX + rcLockWidth - newX);
-    rcLockHeight = (y + h > rcLockY + rcLockHeight) ?
-      (y + h - newY) : (rcLockY + rcLockHeight - newY);
-    rcLockX = newX;
-    rcLockY = newY;
-  }
+	if (!rcLockSet) {
+		rcLockX = x;
+		rcLockY = y;
+		rcLockWidth = w;
+		rcLockHeight = h;
+		rcLockSet = True;
+	} else {
+		newX = (x < rcLockX) ? x : rcLockX;
+		newY = (y < rcLockY) ? y : rcLockY;
+		rcLockWidth = (x + w > rcLockX + rcLockWidth) ?
+		    (x + w - newX) : (rcLockX + rcLockWidth - newX);
+		rcLockHeight = (y + h > rcLockY + rcLockHeight) ?
+		    (y + h - newY) : (rcLockY + rcLockHeight - newY);
+		rcLockX = newX;
+		rcLockY = newY;
+	}
 
-  if (!rcCursorHidden && SoftCursorInLockedArea()) {
-    SoftCursorCopyArea(OPER_RESTORE);
-    rcCursorHidden = True;
-  }
+	if (!rcCursorHidden && SoftCursorInLockedArea()) {
+		SoftCursorCopyArea(OPER_RESTORE);
+		rcCursorHidden = True;
+	}
 }
 
 /*********************************************************************
@@ -381,15 +430,16 @@
 
 void SoftCursorUnlockScreen(void)
 {
-  if (!prevSoftCursorSet)
-    return;
+	if (!prevSoftCursorSet) {
+		return;
+	}
 
-  if (rcCursorHidden) {
-    SoftCursorCopyArea(OPER_SAVE);
-    SoftCursorDraw();
-    rcCursorHidden = False;
-  }
-  rcLockSet = False;
+	if (rcCursorHidden) {
+		SoftCursorCopyArea(OPER_SAVE);
+		SoftCursorDraw();
+		rcCursorHidden = False;
+	}
+	rcLockSet = False;
 }
 
 /*********************************************************************
@@ -401,19 +451,19 @@
 
 void SoftCursorMove(int x, int y)
 {
-  if (prevSoftCursorSet && !rcCursorHidden) {
-    SoftCursorCopyArea(OPER_RESTORE);
-    rcCursorHidden = True;
-  }
+	if (prevSoftCursorSet && !rcCursorHidden) {
+		SoftCursorCopyArea(OPER_RESTORE);
+		rcCursorHidden = True;
+	}
 
-  rcCursorX = x;
-  rcCursorY = y;
+	rcCursorX = x;
+	rcCursorY = y;
 
-  if (prevSoftCursorSet && !(rcLockSet && SoftCursorInLockedArea())) {
-    SoftCursorCopyArea(OPER_SAVE);
-    SoftCursorDraw();
-    rcCursorHidden = False;
-  }
+	if (prevSoftCursorSet && !(rcLockSet && SoftCursorInLockedArea())) {
+		SoftCursorCopyArea(OPER_SAVE);
+		SoftCursorDraw();
+		rcCursorHidden = False;
+	}
 }
 
 
@@ -429,41 +479,169 @@
 	  rcLockY + rcLockHeight > rcCursorY - rcHotY);
 }
 
-static void SoftCursorCopyArea(int oper)
-{
-  int x, y, w, h;
+void new_pixmap(int w, int h) {
 
-  x = rcCursorX - rcHotX;
-  y = rcCursorY - rcHotY;
-  if (x >= si.framebufferWidth || y >= si.framebufferHeight)
-    return;
-
-  w = rcWidth;
-  h = rcHeight;
-  if (x < 0) {
-    w += x;
-    x = 0;
-  } else if (x + w > si.framebufferWidth) {
-    w = si.framebufferWidth - x;
-  }
-  if (y < 0) {
-    h += y;
-    y = 0;
-  } else if (y + h > si.framebufferHeight) {
-    h = si.framebufferHeight - y;
-  }
+	XFreePixmap(dpy, rcSavedArea);
 
-  if (oper == OPER_SAVE) {
-    /* Save screen area in memory. */
-#ifdef MITSHM
-    if (appData.useShm)
-      XSync(dpy, False);
-#endif
-    XCopyArea(dpy, desktopWin, rcSavedArea, gc, x, y, w, h, 0, 0);
-  } else {
-    /* Restore screen area. */
-    XCopyArea(dpy, rcSavedArea, desktopWin, gc, 0, 0, w, h, x, y);
-  }
+	if (w > 0 && h > 0) {
+		rcSavedArea = XCreatePixmap(dpy, DefaultRootWindow(dpy), w, h, visdepth);
+		rcSavedArea_w = w;
+		rcSavedArea_h = h;
+		
+	} else if (image_scale != NULL && scale_x > 0) {
+		int w2 = scale_round(rcWidth,  scale_factor_x) + 2;
+		int h2 = scale_round(rcHeight, scale_factor_y) + 2;
+		rcSavedArea = XCreatePixmap(dpy, DefaultRootWindow(dpy), w2, h2, visdepth);
+		rcSavedArea_w = w2;
+		rcSavedArea_h = h2;
+	} else {
+		rcSavedArea = XCreatePixmap(dpy, DefaultRootWindow(dpy), rcWidth, rcHeight, visdepth);
+		rcSavedArea_w = rcWidth;
+		rcSavedArea_h = rcHeight;
+	}
+}
+
+extern int XError_ign;
+
+static void SoftCursorCopyArea(int oper) {
+	int x, y, w, h;
+	int xs = 0, ys = 0, ws = 0, hs = 0;
+	static int scale_saved = 0, ss_w, ss_h;
+	int db = 0;
+
+	x = rcCursorX - rcHotX;
+	y = rcCursorY - rcHotY;
+	if (x >= si.framebufferWidth || y >= si.framebufferHeight) {
+		return;
+	}
+
+	w = rcWidth;
+	h = rcHeight;
+	if (x < 0) {
+		w += x;
+		x = 0;
+	} else if (x + w > si.framebufferWidth) {
+		w = si.framebufferWidth - x;
+	}
+	if (y < 0) {
+		h += y;
+		y = 0;
+	} else if (y + h > si.framebufferHeight) {
+		h = si.framebufferHeight - y;
+	}
+
+	if (image_scale != NULL && scale_x > 0) {
+		xs = (int) (x * scale_factor_x);
+		ys = (int) (y * scale_factor_y);
+		ws = scale_round(w, scale_factor_x);
+		hs = scale_round(h, scale_factor_y);
+
+		if (xs > 0) xs -= 1;
+		if (ys > 0) ys -= 1;
+		ws += 2;
+		hs += 2;
+	}
+
+	XError_ign = 1;
+
+	if (oper == OPER_SAVE) {
+		/* Save screen area in memory. */
+		scale_saved = 0;
+		if (appData.useXserverBackingStore) {
+			XSync(dpy, False);
+			XCopyArea(dpy, desktopWin, rcSavedArea, gc, x, y, w, h, 0, 0);
+		} else {
+			if (image_scale != NULL && scale_x > 0) {
+				int Bpp = image_scale->bits_per_pixel / 8;
+				int Bpl = image_scale->bytes_per_line;
+				int i;
+				char *src = image_scale->data + y * Bpl + x * Bpp;
+				char *dst = rcSavedScale;
+
+				if (ws > rcSavedArea_w || hs > rcSavedArea_h) {
+					new_pixmap(0, 0);
+				}
+
+if (db) fprintf(stderr, "save: %dx%d+%d+%d\n", ws, hs, xs, ys);
+
+				XPutImage(dpy, rcSavedArea, gc, image, xs, ys, 0, 0, ws, hs);
+
+				XPutImage(dpy, rcSavedArea_0, gc, image_scale, x, y, 0, 0, w, h);
+
+				scale_saved = 1;
+				ss_w = ws;
+				ss_h = hs;
+
+				for (i=0; i < h; i++) {
+					memcpy(dst, src, Bpp * w);
+					src += Bpl;
+					dst += Bpp * w;
+				}
+			} else {
+if (db) fprintf(stderr, "SAVE: %dx%d+%d+%d\n", w, h, x, y);
+				if (w > rcSavedArea_w || h > rcSavedArea_h) {
+					new_pixmap(0, 0);
+				}
+
+				XPutImage(dpy, rcSavedArea, gc, image, x, y, 0, 0, w, h);
+			}
+		}
+	} else {
+
+#define XE(s) if (XError_ign > 1) {fprintf(stderr, "X-%d\n", (s)); db = 1;}
+
+		/* Restore screen area. */
+		if (appData.useXserverBackingStore) {
+			XCopyArea(dpy, rcSavedArea, desktopWin, gc, 0, 0, w, h, x, y);
+XE(1)
+			XGetSubImage(dpy, rcSavedArea, 0, 0, w, h, AllPlanes, ZPixmap, image, x, y);
+XE(2)
+
+		} else {
+			if (image_scale != NULL && scale_x > 0) {
+				int Bpp = image_scale->bits_per_pixel / 8;
+				int Bpl = image_scale->bytes_per_line;
+				int i;
+				char *dst = image_scale->data + y * Bpl + x * Bpp;
+				char *src = rcSavedScale;
+
+				XCopyArea(dpy, rcSavedArea, desktopWin, gc, 0, 0, ws, hs, xs, ys);
+XE(3)
+				XGetSubImage(dpy, rcSavedArea, 0, 0, ws, hs, AllPlanes, ZPixmap, image, xs, ys);
+XE(4)
+if (db) fprintf(stderr, "rstr: %dx%d+%d+%d\n", ws, hs, xs, ys);
+
+				for (i=0; i < h; i++) {
+					memcpy(dst, src, Bpp * w);
+					src += Bpp * w;
+					dst += Bpl;
+				}
+			} else {
+
+				if (scale_saved) {
+					XCopyArea(dpy, rcSavedArea, desktopWin, gc, 0, 0, ss_w, ss_h, x, y);
+XE(5)
+					XGetSubImage(dpy, rcSavedArea, 0, 0, ss_w, ss_h, AllPlanes, ZPixmap, image, x, y);
+XE(6)
+					new_pixmap(w, h);
+				} else {
+					XCopyArea(dpy, rcSavedArea, desktopWin, gc, 0, 0, w, h, x, y);
+XE(7)
+					XGetSubImage(dpy, rcSavedArea, 0, 0, w, h, AllPlanes, ZPixmap, image, x, y);
+XE(8)
+				}
+
+if (db) fprintf(stderr, "RSTR: %dx%d+%d+%d\n", w, h, x, y);
+
+			}
+		}
+	}
+
+	if (XError_ign > 1) {
+		fprintf(stderr, "XError_ign: %d, oper: %s\n", XError_ign, oper ? "restore" : "save");
+	}
+
+	XError_ign = 0;
 }
 
 static void SoftCursorDraw(void)
@@ -472,43 +650,182 @@
   int offset, bytesPerPixel;
   char *pos;
 
+#define alphahack
+#ifdef alphahack
+  /* hack to have cursor transparency at 32bpp <runge@karlrunge.com> */
+  int alphablend = 0;
+
+  if (!rcSource) {
+  	return;
+  }
+
+  if (appData.useCursorAlpha) {
+  	alphablend = 1;
+  }
+
   bytesPerPixel = myFormat.bitsPerPixel / 8;
 
-  /* FIXME: Speed optimization is possible. */
-  for (y = 0; y < rcHeight; y++) {
-    y0 = rcCursorY - rcHotY + y;
-    if (y0 >= 0 && y0 < si.framebufferHeight) {
-      for (x = 0; x < rcWidth; x++) {
-	x0 = rcCursorX - rcHotX + x;
-	if (x0 >= 0 && x0 < si.framebufferWidth) {
-	  offset = y * rcWidth + x;
-	  if (rcMask[offset]) {
-	    pos = (char *)&rcSource[offset * bytesPerPixel];
-	    CopyDataToScreen(pos, x0, y0, 1, 1);
-	  }
+  if (alphablend && bytesPerPixel == 4) {
+	unsigned long pixel, put, *upos, *upix;
+	int got_alpha = 0, rsX, rsY, rsW, rsH;
+	static XImage *alpha_image = NULL;
+	static int iwidth = 192;
+
+	if (! alpha_image) {
+		/* watch out for tiny fb (rare) */
+		if (iwidth > si.framebufferWidth) {
+			iwidth = si.framebufferWidth;
+		}
+		if (iwidth > si.framebufferHeight) {
+			iwidth = si.framebufferHeight;
+		}
+
+		/* initialize an XImage with a chunk of desktopWin */
+		alpha_image = XGetImage(dpy, desktopWin, 0, 0, iwidth, iwidth,
+		    AllPlanes, ZPixmap);
 	}
-      }
-    }
+
+	/* first check if there is any non-zero alpha channel data at all: */
+	for (y = 0; y < rcHeight; y++) {
+		for (x = 0; x < rcWidth; x++) {
+			int alpha;
+
+			offset = y * rcWidth + x;
+			pos = (char *)&rcSource[offset * bytesPerPixel];
+
+			upos = (unsigned long *) pos;
+			alpha = (*upos & 0xff000000) >> 24;
+			if (alpha) {
+				got_alpha = 1;
+				break;
+			}
+		}
+		if (got_alpha) {
+			break;
+		}
+	}
+
+	if (!got_alpha) {
+		/* no alpha channel data, fallback to the old way */
+		goto oldway;
+	}
+
+	/* load the saved fb patch in to alpha_image (faster way?) */
+	if (image_scale != NULL && scale_x > 0) {
+		XGetSubImage(dpy, rcSavedArea_0, 0, 0, rcWidth, rcHeight, AllPlanes, ZPixmap, alpha_image, 0, 0);
+	} else {
+		XGetSubImage(dpy, rcSavedArea,   0, 0, rcWidth, rcHeight, AllPlanes, ZPixmap, alpha_image, 0, 0);
+	}
+
+	upix = (unsigned long *)alpha_image->data;
+
+	/* if the richcursor is clipped, the fb patch will be smaller */
+	rsW = rcWidth;
+	rsX = 0;	/* used to denote a shift from the left side */
+	x = rcCursorX - rcHotX;
+	if (x < 0) {
+		rsW += x;
+		rsX = -x;
+	} else if (x + rsW > si.framebufferWidth) {
+		rsW = si.framebufferWidth - x;
+	}
+	rsH = rcHeight;
+	rsY = 0;	/* used to denote a shift from the top side */
+	y = rcCursorY - rcHotY;
+	if (y < 0) {
+		rsH += y;
+		rsY = -y;
+	} else if (y + rsH > si.framebufferHeight) {
+		rsH = si.framebufferHeight - y;
+	}
+
+	/*
+	 * now loop over the cursor data, blend in the fb values,
+	 * and then overwrite the fb (CopyDataToScreen())
+	 */
+	for (y = 0; y < rcHeight; y++) {
+		y0 = rcCursorY - rcHotY + y;
+		if (y0 < 0 || y0 >= si.framebufferHeight) {
+			continue;	/* clipped */
+		}
+		for (x = 0; x < rcWidth; x++) {
+			int alpha, color_curs, color_fb, i;
+
+			x0 = rcCursorX - rcHotX + x;
+			if (x0 < 0 || x0 >= si.framebufferWidth) {
+				continue;	/* clipped */
+			}
+
+			offset = y * rcWidth + x;
+			pos = (char *)&rcSource[offset * bytesPerPixel];
+
+			/* extract secret alpha byte from rich cursor: */
+			upos = (unsigned long *) pos;
+			alpha = (*upos & 0xff000000) >> 24;	/* XXX MSB? */
+
+			/* extract the pixel from the fb: */
+			pixel = *(upix + (y-rsY)*iwidth + (x-rsX));
+
+			put = 0;
+			/* for simplicity, blend all 4 bytes */
+			for (i = 0; i < 4; i++) {
+				int sh = i*8;
+				color_curs = ((0xff << sh) & *upos) >> sh;
+				color_fb   = ((0xff << sh) & pixel) >> sh;
+
+				/* XXX assumes pre-multipled color_curs */
+				color_fb = color_curs
+				    + ((0xff - alpha) * color_fb)/0xff;
+				put |= color_fb << sh;
+			}
+			/* place in the fb: */
+	    		CopyDataToScreen((char *)&put, x0, y0, 1, 1);
+		}
+	}
+	return;
   }
+oldway:
+#endif
+
+	bytesPerPixel = myFormat.bitsPerPixel / 8;
+
+	/* FIXME: Speed optimization is possible. */
+	for (y = 0; y < rcHeight; y++) {
+		y0 = rcCursorY - rcHotY + y;
+		if (y0 >= 0 && y0 < si.framebufferHeight) {
+			for (x = 0; x < rcWidth; x++) {
+				x0 = rcCursorX - rcHotX + x;
+				if (x0 >= 0 && x0 < si.framebufferWidth) {
+					offset = y * rcWidth + x;
+					if (rcMask[offset]) {
+						pos = (char *)&rcSource[offset * bytesPerPixel];
+						CopyDataToScreen(pos, x0, y0, 1, 1);
+					}
+				}
+			}
+		}
+	}
+	XSync(dpy, False);
 }
 
-static void FreeSoftCursor(void)
+void FreeSoftCursor(void)
 {
-  if (prevSoftCursorSet) {
-    SoftCursorCopyArea(OPER_RESTORE);
-    XFreePixmap(dpy, rcSavedArea);
-    free(rcSource);
-    free(rcMask);
-    prevSoftCursorSet = False;
-  }
+	if (prevSoftCursorSet) {
+		SoftCursorCopyArea(OPER_RESTORE);
+		XFreePixmap(dpy, rcSavedArea);
+		XFreePixmap(dpy, rcSavedArea_0);
+		free(rcSource);
+		rcSource = NULL;
+		free(rcMask);
+		prevSoftCursorSet = False;
+	}
 }
 
 
-static void FreeX11Cursor()
+void FreeX11Cursor()
 {
-  if (prevXCursorSet) {
-    XFreeCursor(dpy, prevXCursor);
-    prevXCursorSet = False;
-  }
+	if (prevXCursorSet) {
+		XFreeCursor(dpy, prevXCursor);
+		prevXCursorSet = False;
+	}
 }
-
